# 
# BD.pm
# 
#   BLACK DIAMOND on Web 
#
# Copyright 2005 ONODA Production 
#
# $Id: BD.pm,v 1.8 2005/03/05 05:24:17 onoda Exp $


package BD;

use File::Basename;

require 'bdlang.pl';

use bdFlagVar;
use bdItemVar;
use bdStringVar;
use bdConst;
use bdBacklog;
use bdExpr;
use bdCommon;


require 'bdconfig.pl';
require 'bdconfdef.pl';



my $bExistMagick = 0;

if(eval('require Image::Magick')){
	# Image::Magick餷
	$bExistMagick = 1;
}



# Singleton
use vars qw( $bdmain );
sub instance {
    return $bdmain if $bdmain;
    $bdmain = __PACKAGE__->new;
}


my $eucpre = qr{(?<!\x8F)};
my $eucpost = qr{
    (?=                         
	(?:[\xA1-\xFE][\xA1-\xFE])* # JIS X 0208  0ʸʾ³
	(?:[\x00-\x7F\x8E\x8F]|\z)  # ASCII, SS2, SS3 ޤϽü
	)
}x;
my $openclose = qr/\([^()]*(?:(??{$openclose})[^()]*)*\)/;


# 󥹥ȥ饯
sub new{
	my $pkg = shift;

	my $self = bless { },$pkg;

	$self->init();
	return $self;
}

sub init{
	my $self  = shift;

	# BLACK DIAMOND˴ط륯饹
	$self->{flagvar} = $gFlags;
	$self->{itemvar} = $gItems;
	$self->{stringvar} = $gStrings;

	# Хå
	$self->{backlog} = $gBacklog;

	# ֺǽȯ
	$self->{startScene} = '';

	# ߽Ƥ륷̾
	$self->{currentScene} = '';
	# ߽Ƥե륪եå
	$self->{currentFileOffset} = 0;
	# ߽Υޥɥꥹ
	$self->{cmdList} = [];


	$self->{gameName} = '';

	# MODE_EXECȥץȼ¹档MODE_KEYWAITȥڡԤMODE_INPUTȥޥɼդԤ
	$self->{gameMode} = bdConst::MODE_INPUT;
	
	# ƸĿͤβ̴Ѳե
	$self->{ScreenImageFile} = "";
	$self->{LastDispPicture} = "";

	# ʸ
	$self->{outputStr} = '';

	# ֥ɥʸ
	$self->{subwinStr} = '';

	# ɥꥹ
	$self->{keyWords} = $gKeywords;

	# GOSUBå
	$self->{gosubStack} = [];

	# CHECKSTRICT
	$self->{isCheckStrict} = 0;


	# 󤷤Ƥ桼̾(''ȥ󤷤Ƥʤ)
	$self->{loginUser} = undef;

	# IFȴ⡼()ɤ
	$self->{ifMode} = 0;

	# IFα黻Ҥ = ξ礬뤫
	$self->{ifCheckMode} = 0;		# OLD MODE

	# Υȥ
	$self->{gameTitle} = '';

	# ꡼󥵥
	$self->{scr_x} = 320;
	$self->{scr_y} = 240;
	# ꡼󥹥
	$self->{scr_scale} = 1;

	# ɽ(Υեå)
	$bd->{grp_x} = 0;
	$bd->{grp_y} = 0;

	# åɽ(Υեå)
	$bd->{msg_x} = 'auto';
	$bd->{msg_y} = 'auto';

	# BGMط
	$bd->{bgmFile} = '';
	$bd->{bgmLoop} = 0;
	$bd->{bgmOpen} = 0;


	# ֥ɥʸή⡼ɤ
	$self->{subwinMode} = 0;

	# ֥ɥɽ(ϥ֥ɥ򥯥饹ˤ٤)
	$self->{subwinInfo} = '0';

	# ʸɥ饤֥ν
	&BD::bdlang_code;

	# ܥơ֥(Ȥ٥륤ǥåơ֥)ν
	%gSymbolTable = ();

	# ǡTITLE׻꤬줿˳Ǽ륿ȥ
	$gTitle = '';
}


# ե饰ľܥ
sub Flags
{
	return BD->instance->{flagvar};
}

# ƥľܥ
sub Items
{
	return BD->instance->{itemvar};
}

# ʸѿľܥ
sub Strings
{
	return BD->instance->{stringvar};
}



# ޥɥꥹȤ
sub CmdList
{
	my $self = shift;

	return $self->{cmdList};
}

# ȥ
sub startScene
{
	my $self = shift;

	return $self->{startScene};
}

# ȥ
sub currentScene
{
	my $self = shift;

	return $self->{currentScene};
}

# ȥꤹ
sub set_currentScene
{
	my $self = shift;
	my $scene = shift;

	$self->{currentScene} = $scene;
}


# ץȥС
sub script_convert {
	my $self = shift;
	my $line;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	my $scrName = "$gScriptPath" . $self->{gameName} . "/$gGameScriptName";
	open(FP, "<$scrName");

	my @scripts = ();
	while ( <FP> ) {
		$line = $_;

		# SJISEUC ؤѴ
		$line = &bdlang_conv($line, 'euc', 'sjis');
		# ԥɺ(ʤ)
		$line =~ tr/\x0D\x0A//d;$character = "";
		# ƬΥڡ֤(ѥڡϺʤ)
		$line =~ s/^(?:\s|\t)+//o;
		# Υڡ֤(ѥڡϺʤ)
		#$line =~ s/^((?:$ascii|$twoBytes|$threeBytes)*?)(?:\s|\t)+$/$1/o;
		$line =~ s/(?<!\x8F)(?:\s|\t)+$//o;
		# Ȥ
		$line = bdUtil::Replace($line, '#.*', '');

		if($line ne ''){
			# 줬٤
			push @scripts, ($line . "\n");
		}

	}
	close(FP);

	# 񤭽ФƤ
	my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";
	open(FP, ">$scrOutName");
	print FP @scripts;
	close(FP);

	# å
	bdUtil::my_funlock($lfh);

}

# ޥɥꥹȤΥꥢ
sub clear_command {
	my $self = shift;
	$self->{cmdList} = [];
}

# ޥɤɲ
sub add_command {
	my $self = shift;
	my $cmd = shift;
	my $ofs = shift;

	my @cmdLine = ();
	while(($cmd =~ /^($eucpre(?:[^\s]+)$eucpost)\s+(.*)/) || ($cmd =~ /^($eucpre(?:.+)$eucpost)/)) {
		$cmdPiece = $1;
		$cmd = $2;

		my @cmdOne = ();
		while(($cmdPiece =~ /^($eucpre(?:[^\/]+)$eucpost)\/(.*)/) || ($cmdPiece =~ /^($eucpre(?:.+)$eucpost)()/)) {
			push @cmdOne, $1;
			$cmdPiece = $2;
		}
		push @cmdLine, [@cmdOne];
	}
	my $pcmdList = $self->{cmdList};

	push @{$pcmdList}, {$ofs => [@cmdLine]};			# ʥϥå(ե륪եåȤ򥭡ȤƥޥˤĤʤ)
}

# ץȤΥȰ֤(եΰ֤ưʤƤϤ)
sub set_script_current {
	my $self = shift;
	my $ofs = shift;

#	my $lfh = bdUtil::my_flock() or die 'Busy!';

#	my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";
#	open(FPCUR, "<$scrOutName");
#	seek(FPCUR,$ofs,0);

	$self->{currentFileOffset} = $ofs;

#	close(FPCUR);

#	# å
#	bdUtil::my_funlock($lfh);

}

# ޥõ
sub search_command {
	my $self = shift;
	my $cmd = shift;
	my $cmdcopy = $cmd;
	my $ret;
	my $nomatchOfs;


	# ޥõ
	my $cmdList = $self->{cmdList};
	foreach $cmdLnHash (@{$cmdList}) {
		my $lineSame = 1;

		my ($ofs, $cmdLn) = each %{$cmdLnHash};

		$cmd = $cmdcopy;

		foreach $cmdOne (@{$cmdLn}) {
			my $oneSame = 0;
			foreach $cmdVal (@{$cmdOne}) {
				my $cnt = @{$cmdLn};
				#print "$cmdVal : $cmd<br>";
				if($cnt == 1){
					if($cmdVal eq 'NOMATCH'){
						$nomatchOfs = $ofs;
					}
					if ($cmd eq $cmdVal) {
						$oneSame = 1;
						last;
					}
				} else {
					if ($cmd =~ /$eucpre\Q$cmdVal\E$eucpost/) {      # ɥޥå
						if($self->{isCheckStrict}){
							$cmd =~ s/$eucpre\Q$cmdVal\E$eucpost/\*/;
						}
						$oneSame = 1;
						last;
					}
				}
			}
			# ɤ줫ĤǤޥåƤɤ
			if($oneSame != 1){
				# ޥåʤäΤǤΥޥɤ̵
				$lineSame = 0;
				last;
			}
		}
		if($lineSame == 1){
			# פΤǰ׸Ȥ
			$ret = $ofs;
		}
	}

	# פʤä,餫¸ƤNOMATCHΥեåȤ֥
	# NOMATCH̵undef֤
	if(!$ret){
		$ret = $nomatchOfs;
	}

	return $ret;
}


# ץȤɤ(ܥơ֥䥢ƥνʤɤ򥪥ץǻǽ)
sub load_script {
	my $self = shift;
	my $options_ref = shift;
	my %options = %{$options_ref};		# Ȥ᤹
	my $line;
	my $currentScene;


	my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";
	if (!-f $scrOutName) {		# ѴΥץȤ̵ϤѴ
		$self->script_convert();
	}

	open(FP, "<$scrOutName");

	if($options{'SymbolTable'}){
		# ܥơ֥(ϥå)ν
		%gSymbolTable = ();
	}

	if($options{'ItemInit'}){
		$self->{itemvar}->clear();
	}

	my $label;
	my $itemmode = 0;
	# ƥ򽦤äƥƥν
	while ( <FP> ) {
		$line = $_;
		# ԥɺ
		$line =~ tr/\x0D\x0A//d;
		if($itemmode == 1){
			# ƥ
			if( $line =~ /^\*ITEMEND/ ){
				$itemmode = 0;
				next;
			}

			if ($line =~ /^($eucpre(?:.+)$eucpost)\s+([0-9]*)/) {          # ѥޥå
				$val = $2;
				if(!$val){ $val = 0; }
				$self->{itemvar}->set_item($1,$val);
			}
		} else {
			# SymbolTable => 󡢥٥ΥեåϿ
			if($options{'SymbolTable'}){
				if( ($line =~ /^\*SCENE\s+(.*)/) || ($line =~ /^\*LABEL\s+(.*)/)){
					$label = $1;
					if($line =~ /^\*SCENE\s+(.*)/){			# Ĺ
						$currentScene = $1;
					}

					if($self->{startScene} eq ''){
						# ǽΥꤵƤʤꤹ
						$self->{startScene} = $1;
					}

#					$label = bdExpr::convert("'$label'");		# ɬפʤϤʤΤǼɾϤʤ
					$gSymbolTable{$label} = [tell(FP), $currentScene];		# եåȤȥȥˤƤġġ
				}
			}

			# ItemInit => ƥν
			if($options{'ItemInit'}){
				if( $line =~ /^\*ITEM$/ ){
					$itemmode = 1;
				}
			}

			# SystemInit => ƥط(ȥ롢̥)
			if($options{'SystemInit'}){
				if( $line =~ /^\*TITLE\s+(.*)/ ){
					$self->{gameTitle} = $1;
					$gTitle = $1;
				} elsif( $line =~ /^\*SCREEN\s+([0-9]+)\s+([0-9]+)/ ){
					$self->{scr_x} = $1;
					$self->{scr_y} = $2;

					# screenν(ImageMagickΤ)
					if($bExistMagick){
						my $backimg = Image::Magick->new();;
						my $sz = "$self->{scr_x}x$self->{scr_y}";
						$backimg->Set(size=> $sz );
						$backimg->ReadImage("xc:black");
						$backimg->Write($self->{ScreenImageFile});
					}
				}
			}
			
			# ޥɥơ֥
			if($options{'CommandRead'}){
				if( ($line =~ /^>(.*)/) || ($line =~ /^\](.*)/) ){
					$self->add_command($1,tell(FP));
				}
			}


		}
	}

	close(FP);
}



# ⤷̾ꤵƤʤФǽͤꤹ
sub setupGameName {
	my $self = shift;

	if(!$self->{gameName}){
		my $key = $gGameList[0];			# 

		my $name = $gGameTitleList{$key};
		$self->{gameName} = $key;
		$self->{gameTitle} = $name;
	}
}


# GETITEM
sub exec_getitem {
	my $self = shift;
	my $cmd = shift;

	my $itm = &get_token(\$cmd);
	$itm = bdExpr::convert($itm);

	$self->{itemvar}->set_item($itm,1);

}

# DELTITEM
sub exec_delitem {
	my $self = shift;
	my $cmd = shift;

	my $itm = &get_token(\$cmd);
	$itm = bdExpr::convert($itm);

	$self->{itemvar}->set_item($itm,0);

}

# USEITEM
sub exec_useitem {
	my $self = shift;
	my $cmd = shift;

	my $itm = &get_token(\$cmd);
	$itm = bdExpr::convert($itm);

	$self->{itemvar}->set_item($itm,-1);

}

# ITEMLIST
sub exec_itemlist {
	my $self = shift;
	my $cmd = shift;
	my $key,$value;

	$self->{outputStr} .= "[ƥ]<br>";
	while ( ( $key , $value ) = each %{ $self->{itemvar}->{items} } ){
		if($value > 0){
			$self->{outputStr} .= $key . '';
		}
	}
}

sub exec_procitemall {
	my $self = shift;
	my $cmd = shift;
	my $mode = shift;		# 0=del  1=init
	my $key,$value;

	if($mode == 0){
		while ( ( $key , $value ) = each %{ $self->{itemvar}->{items} } ){
			# $valueʤɤ
			$self->{itemvar}->set_item( $key, 0 );
		}
	} else {
		# ᤹ͤ
		my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";

		open(IFP, "<$scrOutName");

		my $itemmode = 0;
		my $line;
		# ƥ򽦤äƥƥν
		while ( <IFP> ) {
			$line = $_;
			# ԥɺ
			$line =~ tr/\x0D\x0A//d;
			if($itemmode == 1){
				# ƥ
				if( $line =~ /^\*ITEMEND/ ){
					$itemmode = 0;
					last;
				}

				if ($line =~ /^($eucpre(?:.+)$eucpost)\s+([0-9]*)/) {          # ѥޥå
					$val = $2;
					if(!$val){ $val = 0; }
					$self->{itemvar}->set_item($1,$val);
				}
			} else {
				# ItemInit => ƥν
				if( $line =~ /^\*ITEM$/ ){
					$itemmode = 1;
				}
			}
		}
		close(IFP);
	}
}


# INPUT
sub exec_input {
	my $self = shift;
	my $cmd = shift;

	my $msg = &get_token(\$cmd);
	$msg = bdExpr::convert("'$msg'");

	$self->{outputStr} .= $msg . "<br>";

	my $lvar = &get_token(\$cmd);
	my $sujimoji = &get_token(\$cmd);

	$self->{inputLVar} = $lvar;
	$self->{inputSuji} = $sujimoji;

}

sub return_input {
	my $self = shift;
	my $val = shift;

	if($self->{inputSuji} == 0){
		# Τߡ
		if(!($val =~ /[0-9]+/)){
			$self->{errorStr} .= "ΤߤϤƤ<br>";
			# ʤ
			return 1;
		}
	}

	if(!($val =~ /[0-9]+/)){
		# 'äƤ''ִ
		$val = bdUtil::Replace( $val, "'", "''");
		# פġġ
		$val = $self->{inputLVar} . "='$val'";
	} else {
		$val = $self->{inputLVar} . "=$val";
	}


	# μ¹
	bdExpr::convert( $val );
	return 0;
}

# YESNO
sub exec_yesno {
	my $self = shift;
	my $cmd = shift;

	my $msg = &get_token(\$cmd);
	$msg = bdExpr::convert("'$msg'");

	$self->{outputStr} .= $msg . "<br>";

	my $lvar = &get_token(\$cmd);
	my $rvar = &get_token(\$cmd);

	$self->{inputLVar} = $lvar;
	$self->{inputRVar} = $rvar;

#	print "INPUT:$msg,$lvar<br>";

}

sub return_yesno {
	my $self = shift;
	my $val = shift;
	my $jmplb;


	if($val eq 'yes'){
		$jmplb = $self->{inputLVar};
	} else {
		$jmplb = $self->{inputRVar};
	}

	$jmplb = bdExpr::convert("'$jmplb'");

	$self->exec_goto( $jmplb );

}


sub search_next_if {
	my $self = shift;
	my $FP = shift;
	my $ifcnt = 0;
	my $myFP = tell($FP);

	while(<$FP>){
		$line = $_;
		# Ժ
		$line =~ tr/\x0D\x0A//d;

		if($line =~ /^\*IF\s/i){
			# 2005/02/14 $cmdƤʤäΤ
			my $cmd = $line;
			&get_token(\$cmd);		# IF CUT
			# οå
			# 2ĤλΤ߹¤IFȤifcntû
			my $var = &get_token(\$cmd);
			my $label = &get_token(\$cmd);
			if(!defined($label)){
				$ifcnt++;
			}
		} elsif($line =~ /^\*ENDIF/i){
			if($ifcnt){
				$ifcnt--;
			} else {
				# бIF
				$self->{currentFileOffset} =  $myFP;
				seek($FP, $myFP , 0);
				last;
			}
		} elsif(($line =~ /^\*ELIF/i) || ($line =~ /^\*ELSE/i)){
			if($ifcnt == 0){
				# бELIFʤΤǼǽƤ餦
				$self->{currentFileOffset} =  $myFP;
				seek($FP, $myFP , 0);
				last;
			}
		} elsif(($line =~ /^\*SCENEEND/i) || ($line =~ /^\*END\s/i) || ($line =~ /^>/)){
			if($ifcnt >= 0){
				$self->{outputStr} .= $line . "Error: ELSEELIFENDIFޤ<br>";
			}
		}

		$myFP = tell($FP);
	}
}

# CMDIF
sub exec_cmdif {
	my $self = shift;
	my $cmd = shift;
	my $FP = shift || undef;

	my $var = &get_token(\$cmd);
	my $label = &get_token(\$cmd);

#	if($self->{ifCheckMode} == 0){
		# CMDIF϶Ū˵⡼ɤʤΤǱ黻Ҥ===Ѵ
		# ''ʸѴƤޤΤǡ⤷äӤΤǤ
		# IFMODE1ˤ
#		'==', '<=', '>=', '!=','+=','-=','*=','/=','%=','<<=','>>=','&=','|=','^=','=~'
		my $pattern = '([^<>!\+\-\*/\%\&\|\^=])=([^=~])';				# ɽǤΤʡ
		my $replace = '==';
		$var =~ s/$eucpre(?:$pattern)$eucpost/\1$replace\2/g;     # ѥִ
#	}

	$var = bdExpr::convert($var);
	if($label){
		$label = bdExpr::convert("'$label'");
		# GOTO IF
		if($var != 0){
			# ΩʤΤǥ
			if( exists($gSymbolTable{$label}) ){
				if($FP){
					seek($FP, ${$gSymbolTable{$label}}[0] , 0);
				}
			}
		}
	} else {
		# ¤CMDIF¸ߤʤ
	}
}

# IFMODE
sub exec_ifmode {
	my $self = shift;
	my $cmd = shift;

	my $var = &get_token(\$cmd);
	$var = bdExpr::convert( $var );

	$self->{ifCheckMode} = $var;
}

# IF
sub exec_if {
	my $self = shift;
	my $cmd = shift;
	my $FP = shift || undef;

	my $var = &get_token(\$cmd);
	my $label = &get_token(\$cmd);

	$self->{ifMode} = 0;

	if($self->{ifCheckMode} == 0){
		# ⡼ɤʤΤǱ黻Ҥ===Ѵ
		# ''ʸѴƤޤΤǡ⤷äӤΤǤ
		# IFMODE1ˤ
#		'==', '<=', '>=', '!=','+=','-=','*=','/=','%=','<<=','>>=','&=','|=','^=','=~'
		my $pattern = '([^<>!\+\-\*/\%\&\|\^=])=([^=~])';				# ɽǤΤʡ
		my $replace = '==';
		$var =~ s/$eucpre(?:$pattern)$eucpost/\1$replace\2/g;     # ѥִ
	}

	$var = bdExpr::convert($var);
	if($label){
		$label = bdExpr::convert("'$label'");
		# GOTO IF
		if($var != 0){
			$self->exec_goto( $label, $FP );
		}
	} else {
		# ¤IF
		if($var == 0){
			# ΩäƤʤΤǼбIF(ELIF or ENDIF)õ
			$self->search_next_if($FP);
			$self->{ifMode} = 1;
		}
	}
}

# CHECKSTRICT
sub exec_checkstrict {
	my $self = shift;
	my $cmd = shift;

	my $var = &get_token(\$cmd);

	$var = bdExpr::convert($var);

	$self->{isCheckStrict} = $var;
}


# GRPPOS
# кɸ
sub exec_grppos {
	my $self = shift;
	my $cmd = shift;
	my $gx = &get_token(\$cmd);
	my $gy = &get_token(\$cmd);

	$gx = bdExpr::convert($gx);
	$gy = bdExpr::convert($gy);

	$self->{grp_x} = $gx;
	$self->{grp_y} = $gy;
}


# MSGPOS
# üкɸ"auto"ˤ
sub exec_msgpos {
	my $self = shift;
	my $cmd = shift;
	my $mx = &get_token(\$cmd);
	my $my = &get_token(\$cmd);

	$mx = bdExpr::convert($mx);
	$my = bdExpr::convert($my);

	$self->{msg_x} = $mx;
	$self->{msg_y} = $my;
}


# CLS
sub exec_cls {
	my $self = shift;


	if($self->{subwinMode}){
		# ֥ɥʸ
		$self->{subwinStr} = '';
	} else {
		# ᥤʸ&Хåꥢ
		$self->{outputStr} = '';
		$self->{backlog}->clear();
	}

}

# SUBWINSHOW
sub exec_subwinshow {
	my $self = shift;
	my $cmd = shift;
	my $flg;
	my $x = undef;
	my $y, $w, $h;
	
	$flg = &get_token(\$cmd);
	$flg = bdExpr::convert($flg);

	$x = &get_token(\$cmd);
	if(defined( $x )){
		# xy,w,h⤢ΤȤ(ȴ)
		$x = bdExpr::convert($x);
		$y = bdExpr::convert(&get_token(\$cmd));
		$w = bdExpr::convert(&get_token(\$cmd));
		$h = bdExpr::convert(&get_token(\$cmd));

	}
	# ɸȽ
	if(!defined($x)){
		$x = -4;
		$y = 16;
	}

	if(!$w){
		$w = 100;
		$h = 80;
	}

	# ȴ
	$self->{subwinInfo} = "$flg,$x,$y,$w,$h";
}


# IFPICTURE
sub exec_ifpicture {
	my $self = shift;
	my $cmd = shift;

	my $var = &get_token(\$cmd);

	if($self->{ifCheckMode} == 0){
		# ⡼ɤʤΤǱ黻Ҥ===Ѵ
		# ''ʸѴƤޤΤǡ⤷äӤΤǤ
		# IFMODE1ˤ
#		'==', '<=', '>=', '!=','+=','-=','*=','/=','%=','<<=','>>=','&=','|=','^=','=~'
		my $pattern = '([^<>!\+\-\*/\%\&\|\^=])=([^=~])';				# ɽǤΤʡ
		my $replace = '==';
		$var =~ s/$eucpre(?:$pattern)$eucpost/\1$replace\2/g;     # ѥִ
	}
#	print "$var<br>";

	$var = bdExpr::convert($var);
	if($var != 0){
		$self->exec_picture($cmd);		# ³PICTURE
	}
}


# PICTURE
sub exec_picture {
	my $self = shift;
	my $cmd = shift;
	my $x,$y,$trans;

	# ե̾
	my $fname = &get_token(\$cmd);
	# ѿִƤʤäΤǽ(0.3.1)
	$fname = bdExpr::convert("'$fname'");
	# X
	my $x = &get_token(\$cmd);
	if($x ne undef){
		$x = bdExpr::convert($x);
		# Y
		$y = &get_token(\$cmd);
		$y = bdExpr::convert($y);
		$trans = &get_token(\$cmd) || 0;
		$trans = bdExpr::convert($trans);
	} else {
		$x = 0;
		$y = 0;
		$trans = 0;
	}
	$fname = "$gGraphicsPath".$self->{gameName}. "/$fname";
	
	if(!-f "$fname"){
		if(!-f "$fname.png"){
			if(!-f "$fname.jpg"){
				if(!-f "$fname.bmp"){
					print "Error: File Not Found $fname";
					return;
				} else {
					$fname = "$fname.bmp";
				}
			} else {
				$fname = "$fname.jpg";
			}
		} else {
			$fname = "$fname.png";
		}
	}

	if($bExistMagick){
		my $backimg = Image::Magick->new();;
		if(-f $self->{ScreenImageFile}){
			$backimg->Read( $self->{ScreenImageFile} );
		} else {
			if($self->{scr_x} == 0){
				$self->{scr_x} = 320;
			}
			if($self->{scr_y} == 0){
				$self->{scr_y} = 240;
			}
			my $sz = "$self->{scr_x}x$self->{scr_y}";
			$backimg->Set(size=> $sz );
			$backimg->ReadImage("xc:black");
			
			print "$sz<br>";
		}

		my $img = Image::Magick->new();
		$img->Read( $fname );
		if($trans != 0){
			$img->Transparent( color => '#0000ff');
		}
	
		my ($ow, $oh)= $backimg->Get('width', 'height');
		my ($iw, $ih)= $img->Get('width', 'height');
		$iw += $x;
		$ih += $y;
		if(($ow < $x) || ($oh < $x)){
			if($ow < $x){ $ow = $x; }
			if($oh < $y){ $oh = $y; }
			$backimg->Set(size=> ("$ow" . "x" . "$oh"));
		}

		$backimg->Composite(image=>$img, compose=>"Over", x=>$x, y=>$y);
		$backimg->Write( $self->{ScreenImageFile} );
	} else {
		# Image::Magick̵ϡñɽScreenե򡢤pictureڤؤΤ
		$self->{ScreenImageFile} = $fname;
		$self->{LastDispPicture} = $fname;
	}
}

# GOTO
sub exec_goto {
	my $self = shift;
	my $label = shift;
	my $FP = shift || undef;

	if( exists($gSymbolTable{$label}) ){
		# ɤ߹ߤ򤷤饫ȥեåȤϤΥ˰ư
		$self->{currentFileOffset} = ${$gSymbolTable{$label}}[0];
		if($FP){
			seek($FP, $self->{currentFileOffset} , 0);
		}
		if(($self->{currentScene} ne ${$gSymbolTable{$label}}[1]) && ((uc ${$gSymbolTable{$label}}[1]) ne 'GLOBAL')){
			# ѤäΤ(GLOBALʳ)ޥɤľ
			$self->{currentScene} = ${$gSymbolTable{$label}}[1];
			$self->load_scene( $self->{currentScene} );
		}
	}
}

# GOSUB
sub exec_gosub {
	my $self = shift;
	my $label = shift;
	my $FP = shift;

	if( exists($gSymbolTable{$label}) ){
		push @{ $self->{gosubStack} }, $self->{currentScene} . "#" . tell($FP);		# ̾,FP
		$self->{currentFileOffset} = ${$gSymbolTable{$label}}[0];
		if($FP){
			seek($FP, $self->{currentFileOffset} , 0);
		}
	}
}

sub exec_load {
	my $self = shift;
	my $cmd = shift;
	my $num;

	$num = &get_token(\$cmd);
	$num = bdExpr::convert( $num );

	my $fname = "$gSavePath/save_" . $self->{gameName} . "_" . $self->{loginUser} . "_" . $num . ".sav";

	if(-f $fname){
		# 뤫
		$self->load_from_file($fname);

		# 
		if($bExistMagick){
			$fname = "$gSavePath/save_" . $self->{gameName} . "_" . $self->{loginUser} . "_" . $num . ".png";

			my $backimg = Image::Magick->new();;
			if(-f $fname){
				$backimg->Read( $fname );
			} else {
				if($self->{scr_x} == 0){
					$self->{scr_x} = 320;
				}
				if($self->{scr_y} == 0){
					$self->{scr_y} = 240;
				}
				my $sz = "$self->{scr_x}x$self->{scr_y}";
				$backimg->Set(size=> $sz );
				$backimg->ReadImage("xc:black");
			}
			$backimg->Write( $self->{ScreenImageFile}  );
		} else {
			# Image::Magick̵硢ScreenImageFileǸɽѹ
			if($self->{LastDispPicture}){
				$self->{ScreenImageFile} = $self->{LastDispPicture};
			}
		}

		# ȥɤǤ
		$self->load_scene( $self->{currentScene} );

		# BGMĤäƤĤ餹ؼ
		if(($self->{bgmLoop} == 1) && ($self->{bgmFile} ne undef)){
			$self->{bgmOpen} = 1;
		}

		return 0;
	} else {
		$self->{errorStr} .= "֥ǡޤ<br>";

		return 1;
	}

}

sub exec_save {
	my $self = shift;
	my $cmd = shift;
	my $num;

	$num = &get_token(\$cmd);
	$num = bdExpr::convert( $num );

	my $fname = "$gSavePath/save_" . $self->{gameName} . "_" . $self->{loginUser} . "_" . $num . ".sav";

	$self->save_to_file($fname);

	# ĤǤ˲̤⥻
	if($bExistMagick){
		$fname = "$gSavePath/save_" . $self->{gameName} . "_" . $self->{loginUser} . "_" . $num . ".png";

		my $backimg = Image::Magick->new();;
		if(-f $self->{ScreenImageFile}){
			$backimg->Read( $self->{ScreenImageFile} );
		} else {
			if($self->{scr_x} == 0){
				$self->{scr_x} = 320;
			}
			if($self->{scr_y} == 0){
				$self->{scr_y} = 240;
			}
			my $sz = "$self->{scr_x}x$self->{scr_y}";
			$backimg->Set(size=> $sz );
			$backimg->ReadImage("xc:black");
		}
		$backimg->Write( $fname );
	}
}


# BGM
sub exec_bgm {
	my $self = shift;
	my $cmd = shift;

	# ե̾
	my $fname = &get_token(\$cmd);
	$fname = bdExpr::convert("'$fname'");
	# 롼ץե饰
	my $loop = &get_token(\$cmd);
	if($loop ne undef){
		$loop = bdExpr::convert($loop);
	} else {
		$loop = 1;
	}

	$fname = "$gScriptPath2/" . $self->{gameName}. "/$fname";

	if(!-f "$fname"){
		if(!-f "$fname.mid"){
			# mp3ĶǤĤ餻뤬Ĥʤ
			if(!-f "$fname.mp3"){
				print "Error: File Not Found $fname";
				return;
			} else {
				$fname="$fname.mp3";
			}
		} else {
			$fname="$fname.mid";
		}
	}
	# $fnameĤ餹
	# ̵¥롼פʤϾĤ餹
	# Ĥ餹ե̾㤦Ĥ餹
	# ̵¥롼פĤ餹ե̾ƱĤ餵ʤ
	if(($self->{bgmLoop} == 0) || ($self->{bgmFile} ne $fname)){
		$self->{bgmFile} = $fname;
		$self->{bgmLoop} = $loop;
		$self->{bgmOpen} = 1;
	}
}

# BGMSTOP
sub exec_bgmstop {
	my $self = shift;
	my $cmd = shift;

	# undefϤBGMɥĤ
	$self->{bgmFile} = undef;
	$self->{bgmLoop} = 0;
	$self->{bgmOpen} = 1;
}


# ץȤμ¹Խ
sub script_exec {
	my $self = shift;
	my $line;

	my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";
	open(FP, "<$scrOutName");
	seek(FP, $self->{currentFileOffset}, 0);

	my $cnt = 0;
	while(<FP>){
		$line = $_;
		# Ժ
		$line =~ tr/\x0D\x0A//d;

		# ץȤμ¹(ȴ)
		if($line =~ /^\*PICTURE/i){
			# PICTUREʸ
			&get_token(\$line);
			#print "LINE:$line\n";
			$self->exec_picture($line);
		}elsif($line =~ /^\*IFPICTURE/i){
			# IFPICTUREʸ
			&get_token(\$line);
			#print "LINE:$line\n";
			$self->exec_ifpicture($line);
		}elsif($line =~ /^\*GOTO/i){
			# GOTOʸ
			&get_token(\$line);
			$line = &get_token(\$line);
			$line = bdExpr::convert("'$line'");
			$self->exec_goto($line,*FP);
		} elsif($line =~ /^\*GOSUB\s/i){
			# GOSUBʸ
			&get_token(\$line);
			$line = &get_token(\$line);
			$line = bdExpr::convert("'$line'");
			$self->exec_gosub($line,*FP);
		} elsif(($line =~ /^\*\*/i) || ($line =~ /^\*KEYWAIT/i)){
			# Ԥ
			$self->{gameMode} = bdConst::MODE_KEYWAIT;
			last;
		} elsif($line =~ /^\*IF\s/i){
			# IFʸ
			&get_token(\$line);
			$self->exec_if($line,*FP);
		} elsif($line =~ /^\*ELIF\s/i){
			# ELIFʸ
			if( $self->{ifMode} == 1) {			# IFåξϽ
				&get_token(\$line);
				$self->exec_if($line,*FP)
			} else {
				$self->search_next_if(*FP);
			}
		} elsif($line =~ /^\*ELSE/i){
			# ELSEʸ
			if( $self->{ifMode} == 0) {
				$self->search_next_if(*FP);
			}
			$self->{ifMode} = 1;
		} elsif($line =~ /^\*ENDIF/i){
			# ENDIFʸ
			$self->{ifMode} = 0;
		} elsif($line =~ /^\*GETITEM\s/i){
			# GETITEMʸ
			&get_token(\$line);
			$self->exec_getitem($line);
		} elsif($line =~ /^\*DELITEM\s/i){
			# DELITEMʸ
			&get_token(\$line);
			$self->exec_delitem($line);
		} elsif($line =~ /^\*USEITEM\s/i){
			# USEITEMʸ
			&get_token(\$line);
			$self->exec_useitem($line);
		} elsif($line =~ /^\*ITEMLIST/i){
			# ITEMLISTʸ
			&get_token(\$line);
			$self->exec_itemlist($line);
		} elsif($line =~ /^\*INPUT\s/i){
			# INPUTʸ
			&get_token(\$line);
			$self->{gameMode} = bdConst::MODE_INPUTWAIT;
			$self->exec_input($line);
			last;
		} elsif($line =~ /^\*YESNO\s/i){
			# YESNOʸ
			&get_token(\$line);
			$self->{gameMode} = bdConst::MODE_INPUTWAIT2;
			$self->exec_yesno($line);
			last;
		} elsif($line =~ /^\*BGM\s/i){
			# BGMʸ
			&get_token(\$line);
			$self->exec_bgm($line);
		} elsif($line =~ /^\*BGMSTOP/i){
			# BGMSTOPʸ
			&get_token(\$line);
			$self->exec_bgmstop($line);
		} elsif($line =~ /^\*SAVE\s/i){
			# SAVEʸ
			&get_token(\$line);
			$self->exec_save($line);
		} elsif($line =~ /^\*LOAD\s/i){
			# LOADʸ
			&get_token(\$line);
			if(!$self->exec_load($line)){
				last;
			}
		} elsif($line =~ /^\*IFMODE\s/i){
			# IFMODEʸ
			&get_token(\$line);
			$self->exec_ifmode($line);
		} elsif($line =~ /^\*DELITEMALL/i){
			# DELITEMALLʸ
			&get_token(\$line);
			$self->exec_procitemall($line,0);
		} elsif($line =~ /^\*INITITEMALL/i){
			# INITITEMALLʸ
			&get_token(\$line);
			$self->exec_procitemall($line,1);
		} elsif($line =~ /^\*CHECKSTRICT/i){
			# CHECKSTRICTʸ
			&get_token(\$line);
			$self->exec_checkstrict($line);
		} elsif($line =~ /^\*CLS\s*$/i){
			# CLSʸ
			&get_token(\$line);
			$self->exec_cls();
		} elsif($line =~ /^\*SUBWINSTART/i){
			# SUBWINSTARTʸ
			$self->{subwinMode} = 1;
		} elsif($line =~ /^\*SUBWINEND/i){
			# SUBWINENDʸ
			$self->{subwinMode} = 0;
		} elsif($line =~ /^\*SUBWINSHOW/i){
			# SUBWINSHOWʸ
			&get_token(\$line);
			$self->exec_subwinshow($line);
		} elsif($line =~ /^\*GRPPOS/i){
			# GRPPOSʸ
			&get_token(\$line);
			$self->exec_grppos($line);
		} elsif($line =~ /^\*MSGPOS/i){
			# MSGPOSʸ
			&get_token(\$line);
			$self->exec_msgpos($line);
		} elsif($line =~ /^\*GAMEEND/){
			# ཪλ
			$self->{gameMode} = bdConst::MODE_GAMEEND;
			last;
		} elsif( $line =~ /^\*SCREEN\s+([0-9]+)\s+([0-9]+)/ ){
			$self->{scr_x} = $1;
			$self->{scr_y} = $2;

			# screenν(ImageMagickΤ)
			if($bExistMagick){
				my $backimg = Image::Magick->new();;
				my $sz = "$self->{scr_x}x$self->{scr_y}";
				$backimg->Set(size=> $sz );
				$backimg->ReadImage("xc:black");
				$backimg->Write($self->{ScreenImageFile});
			}
		} elsif(($line =~ /^\*SCENEEND/i) || ($line =~ /^\*END/i) || ($line =~ /^>/)){
			# ¹Խλ
			# GOSUBåä
			my $gs = $self->{gosubStack};
			if( $#{ $gs } >= 0){
				my $gsdat = pop @{ $gs };
				my @gsdat2 = split(/\#/,$gsdat);
				my $gsscene = $gsdat2[0];
				my $gsfp    = $gsdat2[1];
				$self->{currentFileOffset} = $gsfp;
				seek(FP, $gsfp , 0);
				# 󤬰ۤʤäƤɤ߹
				if(($self->{currentScene} ne ${$gSymbolTable{$gsscene}}[1]) && ((uc ${$gSymbolTable{$gsscene}}[1]) ne 'GLOBAL')){
					# ѤäΤ(GLOBALʳ)ޥɤľ
					$self->{currentScene} = ${$gSymbolTable{$gsscene}}[1];
					$self->load_scene( $self->{currentScene} );
				}
			} else {
				$self->{gameMode} = bdConst::MODE_INPUT;
				last;
			}
		} elsif(($line =~ /^\*F\(/i) || ($line =~ /^\*I\(/i) || ($line =~ /^\*S\(/i)){
			# ѿη׻äݤ
			$line =~ s/^\*//g;		# Ƭ*
			$line = bdExpr::convert($line);
		} elsif(!(($line =~ /^\*/) || ($line =~ /^\]/))){
			# ʤʸäݤ

			# '''ִ
			$line =~ s/$eucpre(?:')$eucpost/''/g;     # ѥִ

			$line = bdExpr::convert("'$line'");

			# HTMLִ(ʤǡġ)

			# 
			my $openclose = qr/\[[^\[\]]*(?:(??{$openclose})[^\[\]]*)*\]/;
			while ($line =~ /($openclose)/g) {
				# äƤʤäɲä
				my $kw = $1;
				$kw =~ s/$eucpre(?:\[)$eucpost//g;
				$kw =~ s/$eucpre(?:\])$eucpost//g;
				$self->{keyWords}->add( $kw );
			}

			# ɤĴѹ
			$line =~ s/$eucpre(?:\[)$eucpost/<b>/g;
			$line =~ s/$eucpre(?:\])$eucpost/<\/b>/g;

			if(!$self->{subwinMode}){
				# ᥤåؤν
				$self->{outputStr} .= $line . "<br>";
				# ХåؤεϿ
				$self->{backlog}->add( $line );
			} else {
				# ֥ɥؤν
				$self->{subwinStr} .= $line . "<br>";
			}
		} else {
			# ̤̿ or Ƭ ] (¹Խλʤ>)
		}
		$cnt++;
	}
	# μ¹԰֤
	$self->{currentFileOffset} = tell(FP);

	close(FP);

	# Хå
	$self->{backlog}->reduce(bdConst::BACKLOG_LINES);

};


sub get_subwin_html {
	my $self = shift;
	my @info = split(/,/,$self->{subwinInfo});
	my $ret;

	if($info[0]){
		# ֥ɥɽäݤ
		if($info[1] >= 0){
			$ret = '<div class="subwindow" style="width:' . $info[3] . 'px; height:' . $info[4] . 'px; position:absolute; left:' . $info[1] . 'px; top:' .$info[2] . 'px; z-index:1;">';
		} else {
			$ret = '<div class="subwindow" style="width:' . $info[3] . 'px; height:' . $info[4] . 'px; position:absolute; right:' . $info[1]*-1 . 'px; top:' .$info[2] . 'px; z-index:1;">';
		}
		$ret .= $self->{subwinStr};
		$ret .= '</div>';
	} else {
		# ֥ɥɽʤ衼
		$ret = '';
	}

	return $ret;
}


# ɤ߹
sub load_scene {
	my $self = shift;
	my $scene_name = shift;

	# ޥɰΥꥢ
	$self->clear_command;

	if( exists($gSymbolTable{$scene_name}) ){

		my $scrOutName = "$gScriptPath" . $self->{gameName} . "/$gScriptOutName";
		open(LFP, "<$scrOutName");

		# Х륷󤬤Ф­(Ĺ)
		if(($scene_name ne 'GLOBAL') && (exists($gSymbolTable{'GLOBAL'}))){
			seek(LFP,${$gSymbolTable{'GLOBAL'}}[0],0);
			# SCENEENDޤɤ
			while( <LFP> ){
				$line = $_;
				# ԥɺ
				$line =~ tr/\x0D\x0A//d;
				if($line =~ /^\*SCENEEND/i){
					last;
				} else {
					# ޥɤ߹
					if( $line =~ /^\*!IF\s/i){
						# CMDIFʸ
						&get_token(\$line);
						$self->exec_cmdif($line,*LFP);
					} elsif( ($line =~ /^>(.*)/) || ($line =~ /^\](.*)/) ){
						$self->add_command($1,tell(LFP));
					}
				}
			}
		}

		seek(LFP,${$gSymbolTable{$scene_name}}[0],0);
		# SCENEENDޤɤ
		while( <LFP> ){
			$line = $_;
			# ԥɺ
			$line =~ tr/\x0D\x0A//d;
			if($line =~ /^\*SCENEEND/i){
				last;
			} else {
				if( $line =~ /^\*!IF\s/i){
					# CMDIFʸ
					&get_token(\$line);
					$self->exec_cmdif($line,*LFP);
				} elsif( ($line =~ /^>(.*)/) || ($line =~ /^\](.*)/) ){
					# ޥɤ߹
					$self->add_command($1,tell(LFP));
				}
			}
		}
		close(LFP);
	}



}

# ȡڤФ
sub get_token {
	my $str = shift;				# ڤФʸλ
	my $isaffect = shift || 1;		# ʸѹä뤫(0:äʤ 0ʳ:ä(ǥե))
	my $ret = undef;
	my $tmpstr = $$str;

	# Ƭڡ
	$tmpstr =~ s/^(?:\s)+//o;

	if($tmpstr =~ /^\(/ ){
		# ⤷̤ǤƤ顢б̤ޤǤڤФ
		my $tmpstr2 = $tmpstr;
		my $tmpstr3 = $tmpstr;
		$tmpstr2 =~ s/($eucpre(?:$openclose)$eucpost)\s*//;
		my $v1 = $1;
		$tmpstr3 =~ s/($eucpre(?:(?:(?!\s).)*)$eucpost)\s*(.*)//;
		my $v2 = $1;

		# ڡڤĹڤФ硢롣
		if(length($v1)>length($v2)){
			$ret = $v1;
			$tmpstr = $tmpstr2;
		} else {
			$ret = $v2;
			$tmpstr = $tmpstr3;
		}

#		$ret = $1;
	} elsif($tmpstr =~ /($eucpre(?:(?:(?!\s).)*)$eucpost)\s*(.*)/) {		# ̯˾Ĺ
		#  ̤ǤƤʤä顢̤˥ڡڤФ
		$ret = $1;
		if(!length($ret)){	
			# Ĺ
			$ret = undef;
		}
		$tmpstr = $2;							# ʤĹʵġ
	}

	# ʸ˱ƶͿ꤬Ƥ᤹
	if($isaffect != 0){
		$$str = $tmpstr;
	}

	return $ret;
}




# ɼ½
sub load_from_file {
	my $self = shift;
	my $fname = shift;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	open(LFP, "< $fname");
	my @sds = <LFP>;
	close(LFP);

	# å
	bdUtil::my_funlock($lfh);

	my @sd = split(/\n/, join('',@sds));

	my $ver = shift @sd;


	# ط
	$self->{currentScene} = shift @sd;

	# ֺǽȯ
	 $self->{startScene} = shift @sd;

	# ߽Ƥե륪եå
	$self->{currentFileOffset} = shift @sd;

	# ߽Ƥե륪եå
	$self->{gameMode} = shift @sd;

	# ϥ桼եβ˺ɬפ롪
	$self->{ScreenImageFile} = shift @sd;

	# ϥ桼եβ˺ɬפ롪
	$self->{outputStr} = shift @sd;
	$self->{errorStr} = shift @sd;

	# 󤷤Ƥ桼̾
	$self->{loginUser} = shift @sd;

	# ѿط
	$self->{flagvar}->deserialize(shift @sd);
	$self->{itemvar}->deserialize(shift @sd);
	$self->{stringvar}->deserialize(shift @sd);

	# INPUTʸѿ(ޤYESNOǤYES)
	$self->{inputLVar} = shift @sd;
	# YESNOǤNO
	$self->{inputRVar} = shift @sd;

	$self->{inputSuji} = shift @sd;

	$self->{ifMode} = shift @sd;
	$self->{ifCheckMode} = shift @sd;

	$self->{gameTitle} = shift @sd;

	# ꡼󥵥
	$self->{scr_x} = shift @sd;
	$self->{scr_y} = shift @sd;
	# ꡼󥹥
	$self->{scr_scale} = shift @sd;

	# ɥꥹ
	$self->{keyWords}->deserialize(shift @sd);

	# GOSUBå
	my $gosub = shift @sd;
	if($gosub){
		my @values = split(/,/,$gosub);

		@{ $self->{gosubStack} } = @values;
	}


	$self->{gameName} = shift @sd;

	$self->{isCheckStrict} = shift @sd;

	# Ǹɽ
	$self->{LastDispPicture} = shift @sd;

	$self->{backlog}->deserialize(shift @sd);

	# ֥ɥط
	$self->{subwinMode} = shift @sd;
	$self->{subwinStr} = shift @sd;
	$self->{subwinInfo} = shift @sd;

	# ɽִط
	$self->{grp_x} = shift @sd;
	$self->{grp_y} = shift @sd;
	$self->{msg_x} = shift @sd;
	$self->{msg_y} = shift @sd;

	# BGMط
	$self->{bgmFile} = shift @sd;
	$self->{bgmLoop} = shift @sd;
	$self->{bgmOpen} = shift @sd;

}

# ּ½
sub save_to_file {
	my $self = shift;
	my $fname = shift;

	my @sd = ();		# Save Data

	push @sd, "0";

	# ط
	push @sd, $self->{currentScene};

	# ֺǽȯ
	push @sd, $self->{startScene};

	# ߽Ƥե륪եå
	push @sd, $self->{currentFileOffset};

	# ߽Ƥե륪եå
	push @sd, $self->{gameMode};

	# ϥ桼եβ˺ɬפ롪
	push @sd, $self->{ScreenImageFile};

	# ϥ桼եβ˺ɬפ롪
	push @sd, $self->{outputStr};
	push @sd, $self->{errorStr};

	# 󤷤Ƥ桼̾
	push @sd, $self->{loginUser};

	# ѿط
	push @sd, $self->{flagvar}->serialize();
	push @sd, $self->{itemvar}->serialize();
	push @sd, $self->{stringvar}->serialize();

	# INPUTʸѿ(ޤYESNOǤYES)
	push @sd, $self->{inputLVar};
	# YESNOǤNO
	push @sd, $self->{inputRVar};

	push @sd, $self->{inputSuji};

	push @sd, $self->{ifMode};
	push @sd, $self->{ifCheckMode};

	push @sd, $self->{gameTitle};

	# ꡼󥵥
	push @sd, $self->{scr_x};
	push @sd, $self->{scr_y};
	# ꡼󥹥
	push @sd, $self->{scr_scale};

	# ɥꥹ
	push @sd, $self->{keyWords}->serialize();

	# GOSUBå
	$datas = join ',' , @{ $self->{gosubStack} };
	push @sd, $datas;

	# ̾
	push @sd, $self->{gameName};

	# Ǹɽ
	push @sd, $self->{LastDispPicture};

	push @sd, $self->{isCheckStrict};

	push @sd, $self->{backlog}->serialize();

	push @sd, $self->{subwinMode};
	push @sd, $self->{subwinStr};
	push @sd, $self->{subwinInfo};

	push @sd, $self->{grp_x};
	push @sd, $self->{grp_y};
	push @sd, $self->{msg_x};
	push @sd, $self->{msg_y};

	push @sd, $self->{bgmFile};
	push @sd, $self->{bgmLoop};
	push @sd, $self->{bgmOpen};


	my $lfh = bdUtil::my_flock() or die 'Busy!';

	open(SFP, "> $fname");
	print SFP join("\n",@sd);
	close(SFP);

	# å
	bdUtil::my_funlock($lfh);

}

# åؤ¸
sub save_to_session {
	my $self = shift;
	my $sess = shift;

	# ط
	$sess->param("currentScene",$self->{currentScene});

	# ֺǽȯ
	$sess->param("startScene",$self->{startScene});

	# ߽Ƥե륪եå
	$sess->param("currentFileOffset",$self->{currentFileOffset});

	# ߽Ƥե륪եå
	$sess->param("gameMode",$self->{gameMode});

	# ϥ桼եβ˺ɬפ롪
	$sess->param("ScreenImageFile", $self->{ScreenImageFile});

	# ϥ桼եβ˺ɬפ롪
	$sess->param("outputStr", $self->{outputStr});
	$sess->param("errorStr", $self->{errorStr});

	# 󤷤Ƥ桼̾
	$sess->param("loginUser", $self->{loginUser});

	# ѿط
	$sess->param("bdFlag",$self->{flagvar}->serialize);
	$sess->param("bdItem",$self->{itemvar}->serialize);
	$sess->param("bdString",$self->{stringvar}->serialize);

	# INPUTʸѿ(ޤYESNOǤYES)
	$sess->param("inputLVar",$self->{inputLVar});
	# YESNOǤNO
	$sess->param("inputRVar",$self->{inputRVar});

	$sess->param("inputSuji",$self->{inputSuji});

	$sess->param("ifMode",$self->{ifMode});
	$sess->param("ifCheckMode",$self->{ifCheckMode});

	$sess->param("gameTitle",$self->{gameTitle});

	# ꡼󥵥
	$sess->param("scr_x",$self->{scr_x});
	$sess->param("scr_y",$self->{scr_y});
	# ꡼󥹥
	$sess->param("scr_scale",$self->{scr_scale});

	# ɥꥹ

	$sess->param("keyWords", $self->{keyWords}->serialize() );

	# GOSUBå
	$datas = join ',' , @{ $self->{gosubStack} };
	$sess->param("gosubStack", $datas);

	# ̾
	$sess->param("gameName", $self->{gameName});

	$sess->param("LastDispPicture", $self->{LastDispPicture});

	# ̩å롩
	$sess->param("isCheckStrict", $self->{isCheckStrict});

	$sess->param("backlog",$self->{backlog}->serialize);

	$sess->param("subwinMode", $self->{subwinMode} );
	$sess->param("subwinStr", $self->{subwinStr} );
	$sess->param("subwinInfo", $self->{subwinInfo} );


	$sess->param("grp_x",$self->{grp_x});
	$sess->param("grp_y",$self->{grp_y});
	$sess->param("msg_x",$self->{msg_x});
	$sess->param("msg_y",$self->{msg_y});

	$sess->param("bgmFile",$self->{bgmFile});
	$sess->param("bgmLoop",$self->{bgmLoop});
	$sess->param("bgmOpen",$self->{bgmOpen});

	$sess->param("bd_session", 1);

}

# å󤫤ɤ߹
sub load_from_session {
	my $self = shift;
	my $sess = shift;

	# ط
	$self->{currentScene} = $sess->param("currentScene");

	# ֺǽȯ
	$self->{startScene} = $sess->param("startScene");

	# ߽Ƥե륪եå
	$self->{currentFileOffset} = $sess->param("currentFileOffset");

	# ߽Ƥե륪եå
	$self->{gameMode} = $sess->param("gameMode");

	# ϥ桼եβ˺ɬפ롪
	$self->{ScreenImageFile} = $sess->param("ScreenImageFile");

	# ϥ桼եβ˺ɬפ롪
	$self->{outputStr} = $sess->param("outputStr");
	$self->{errorStr} = $sess->param("errorStr");

	# 󤷤Ƥ桼̾
	$self->{loginUser} = $sess->param("loginUser");

	# ѿط
	$self->{flagvar}->deserialize( $sess->param("bdFlag") );
	$self->{itemvar}->deserialize( $sess->param("bdItem") );
	$self->{stringvar}->deserialize( $sess->param("bdString") );

	$self->{inputLVar} = $sess->param("inputLVar");
	$self->{inputRVar} = $sess->param("inputRVar");

	$self->{inputSuji} = $sess->param("inputSuji");

	$self->{ifMode} = $sess->param("ifMode");
	$self->{ifCheckMode} = $sess->param("ifCheckMode");

	$self->{gameTitle} = $sess->param("gameTitle");

	# ꡼󥵥
	$self->{scr_x} = $sess->param("scr_x");
	$self->{scr_y} = $sess->param("scr_y");
	# ꡼󥹥
	$self->{scr_scale} = $sess->param("scr_scale");

	# ɥꥹ
	$self->{keyWords}->deserialize($sess->param("keyWords"));

	# GOSUBå
	my $gosub = $sess->param("gosubStack");
	if($gosub){
		my @values = split(/,/,$gosub);

		@{ $self->{gosubStack} } = @values;
	}

	# ̾
	$self->{gameName} = $sess->param("gameName");

	$self->{LastDispPicture} = $sess->param("LastDispPicture");

	# ̩å롩
	$self->{isCheckStrict} = $sess->param("isCheckStrict");

	$self->{backlog}->deserialize( $sess->param("backlog") );

	$self->{subwinMode} = $sess->param("subwinMode");
	$self->{subwinStr} = $sess->param("subwinStr");
	$self->{subwinInfo} = $sess->param("subwinInfo");

	$self->{grp_x} = $sess->param("grp_x");
	$self->{grp_y} = $sess->param("grp_y");
	$self->{msg_x} = $sess->param("msg_x");
	$self->{msg_y} = $sess->param("msg_y");

	$self->{bgmFile} = $sess->param("bgmFile");
	$self->{bgmLoop} = $sess->param("bgmLoop");
	$self->{bgmOpen} = $sess->param("bgmOpen");

}


sub isExistMagick {
	my $self = shift;

	return $bExistMagick;

}




1;






