# 
# bdAuth.pm
# 
#   BLACK DIAMOND 桼ǧڥ饹
#
# Copyright 2005 ONODA Production 
#
# $Id: bdAuth.pm,v 1.2 2005/01/26 07:04:45 onoda Exp $

package bdAuth;

use BD;
use Time::Local;

# 󥹥ȥ饯
sub new{
	my $pkg = shift;
	my $bd = shift;		# BLACK DIAMOND饹

	# ȤꤢƤƤ
	my $hash= {
		bd  => $bd
	};

	bless $hash,$pkg;
}

# 󤷤Ƥ뤫ɤå
sub is_login {
	my $self = shift;

	return ($self->{bd})->{loginUser};
}

# Ȥ
sub logout {
	my $self = shift;

	if(($self->{bd})->{loginUser}){
		$self->_delLoginList(($self->{bd})->{loginUser});
	}

	($self->{bd})->{loginUser} = undef;
}

# 桼ɲ
sub add_user {
	my $self = shift;
	my $user = shift;
	my $pass = shift;

	# 桼̾ȥѥ¸
	$pass = &mycrypt($pass);
	open(FP, ">> $BD::gPasswordFile");
	print FP "$user $pass\n";
	close(FP);
}

# 桼θ
sub search {
	my $self = shift;
	my $user = shift;
	my $ret = 0;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	open(FP, "< $BD::gPasswordFile");
	while(<FP>){
		# 桼뤫ɤå
		my $line = $_;
		$line =~ tr/\x0D\x0A//d;
		my ($fuser,$fpass) = split(/ /, $line);
		if($fuser eq $user){
			$ret = 1;
			last;
		}
	}
	close(FP);

	# å
	bdUtil::my_funlock($lfh);

	return $ret;
}

# ꥹȤ
sub _delLoginList {
	my $self = shift;
	my $user = shift;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	open(LFP, "< ". $BD::gUserListFile);
	my @users = <LFP>;
	close(LFP);
	my @newuser = ();

	# 뤫ʡ
	foreach $str (@users) {
		my ($u,$tm) = split(/,/,$str);
		if($u ne $user){
			$str =~ tr/\x0D\x0A//d;
			push @newuser, $str;
		}
	}

	open(LFP, "> ". $BD::gUserListFile);
	print LFP join("\n",@newuser);
	close(LFP);

	# å
	bdUtil::my_funlock($lfh);

}

# 󤷤ƤͿ
sub get_login_count {
	my $self = shift;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	open(LFP, "< ". $BD::gUserListFile);
	my @users = <LFP>;
	close(LFP);
	my $usercnt = @users;

	# å
	bdUtil::my_funlock($lfh);


	return $usercnt;
}

# ꥹȤι
sub updateLoginList {
	my $self = shift;
	my $user = shift;
	my $usercnt = 0;
	my $userexist = 0;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	my $mytime = sprintf("%04d/%02d/%02d %02d:%02d:%02d",1900+$year,$mon+1,$mday,$hour,$min,$sec);

	open(LFP, "< ". $BD::gUserListFile);
	my @users = <LFP>;
	close(LFP);

	$usercnt = @users;

	# ﹹ
	my $idx = 0;
	foreach $str (@users) {
		my ($u,$tm) = split(/,/,$str);
		if($u eq $user){
			# Τǻﹹ
			$users[$idx] = "$u,$mytime";
			$userexist = 1;
		} else {
			$users[$idx] =~ tr/\x0D\x0A//d;
		}
		$idx++;
	}

	open(LFP, "> ". $BD::gUserListFile);
	print LFP join("\n",@users);
	close(LFP);

	# å
	bdUtil::my_funlock($lfh);

	# Ȥ줿ΤǥȤ
	if(!$userexist){
		$usercnt = -1;
	}

	return $usercnt;
}

# ꥹȤؤɲ
sub _addLoginList {
	my $self = shift;
	my $user = shift;
	my $userexist = 0;
	my $str;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	my $mytime = sprintf("%04d/%02d/%02d %02d:%02d:%02d",1900+$year,$mon+1,$mday,$hour,$min,$sec);

	open(LFP, "< ". $BD::gUserListFile);
	my @users = <LFP>;
	close(LFP);

	my $usercnt = @users;
	if($usercnt >= bdConst::MAX_USER){
		# ǽͿĶ

		my @newuser = ();
		# ͭĶƤ鶯Ū˥Ȥ
		foreach $str (@users) {
			my ($u,$tm) = split(/,/,$str);
			if($tm =~ /([0-9][0-9][0-9][0-9])\/([0-9][0-9])\/([0-9][0-9]) ([0-9][0-9])\:([0-9][0-9])\:([0-9][0-9])/){
				# μ¤˥ޥåϤ
				my $ltime = timelocal($6,$5,$4,$3,$2-1,$1-1900);
				if($ltime > (time() - bdConst::LOGIN_TIMEOUT)){
					push @newuser, $str;
				}
			}
		}

		$usercnt = @newuser;

		# Ǥʤ硢AdminUserǤʤ
		if(($usercnt >= bdConst::MAX_USER)  && ($user ne $BD::gAdminUser)){
			# å
			bdUtil::my_funlock($lfh);

			return bdConst::MAX_USER;
		} else {
			@users = @newuser;
		}
	} else {
		my @newuser = ();
		# ͭ2ĶƤ鶯Ū˥Ȥ
		foreach $str (@users) {
			my ($u,$tm) = split(/,/,$str);
			if($tm =~ /([0-9][0-9][0-9][0-9])\/([0-9][0-9])\/([0-9][0-9]) ([0-9][0-9])\:([0-9][0-9])\:([0-9][0-9])/){
				# μ¤˥ޥåϤ
				my $ltime = timelocal($6,$5,$4,$3,$2-1,$1-1900);
				if($ltime > (time() - bdConst::LOGIN_TIMEOUT2)){
					push @newuser, $str;
				}
			}
		}

		$usercnt = @newuser;
		@users = @newuser;
	}

	# 뤫ʡ
	my $idx = 0;
	foreach $str (@users) {
		my ($u,$tm) = split(/,/,$str);
		if($u eq $user){
			# Τǻﹹ
			$users[$idx] = "$u,$mytime";
			$userexist = 1;
		} else {
			$users[$idx] =~ tr/\x0D\x0A//d;
		}
		$idx++;
	}
	if(!$userexist){
		push @users, "$user,$mytime";
	}

	open(LFP, "> ". $BD::gUserListFile);
	print LFP join("\n",@users);
	close(LFP);

	# å
	bdUtil::my_funlock($lfh);

	return 0;
}


# (桼̾ѥ)
sub login {
	my $self = shift;
	my $user = shift;
	my $pass = shift;
	my $msg = undef;
	my $login = 0;

	my $lfh = bdUtil::my_flock() or die 'Busy!';

	if($BD::gNoLogin == 0){
		open(FP, "< $BD::gPasswordFile");
		while(<FP>){
			# Ʊ桼Υå
			my $line = $_;
			$line =~ tr/\x0D\x0A//d;
			my ($fuser,$fpass) = split(/ /, $line);
			if($fuser eq $user){
				# ѥɥå
				if(&mydecrypt($pass, $fpass) == 0 ){
					$msg = 'ѥɤ㤤ޤ';
				} else {
					# 桼δ
					$login = 1;
					last;
				}
			}
		}
		close(FP);
	} else {
		$user = "guest";
		$login = 1;
	}

	# å
	bdUtil::my_funlock($lfh);
	
	
	if($login){
		# ǧ$userꥹȤϿ
		my $num;
		$num = $self->_addLoginList($user);
		if(!$num){
			# MAX_USERSʾ󤷤ƤʤΤǥХå
			$self->{bd}->instance->{loginUser} = $user;
			# ̥ե̾κ򤳤ǤäƤΤϤäԵ̣ʤġġ
			$self->{bd}->instance->{ScreenImageFile} = "$BD::gScreenPath/" . $user . "_screen.png";
		} else {
			#  MAX_USERSʾ󤷤ƤΤǥǤʤ
			$msg = 'ߥСߤäƤޤФ餯Ƥ٥󤷤Ƥ<BR>(ǽͿ' .  bdConst::MAX_USER . ")";
		}
	} else {
		# ǧ̤餺
		if(!$msg){
			if(length($user) > 0){
				$msg = '桼̾¸ߤޤ';
			} else {
				$msg = '桼̾ϤƤ';
			}
		}
	}

	return $msg;
}


# decrypt
sub mydecrypt {
	my $salt = $_[1] =~ /^\$1\$(.*)\$/ && $1 || substr($_[1],0,2);
#	print"SALT:$salt:[" . crypt($_[0],$salt) . "][" . $_[1] . "]<br>";
	if (crypt($_[0],$salt) eq $_[1] || crypt($_[0],'$1$' . $salt) eq $_[1]) {return 1;}
	return 0;
}

# crypt
sub mycrypt {
	@salt = ('a' .. 'z','A' .. 'Z','0' .. '9');
	srand;
	$salt = "$salt[int(rand($#salt))]$salt[int(rand($#salt))]";
	return crypt($_[0],$salt);
}

# ǥȥ饯
sub DESTROY
{
}


1;
