# 
# bdUtil.pm
# 
#   BLACK DIAMOND on Web [eBeBNX
#
# Copyright 2005 ONODA Production 
#
# $Id: bdUtil.pm,v 1.3 2005/02/06 03:31:20 onoda Exp $

package bdUtil;

my $ascii = '[\x00-\x7F]';
my $twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
my $threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';

my $eucpre = qr{(?<!\x8F)};
my $eucpost= qr{
	    (?=                         
		(?:[\xA1-\xFE][\xA1-\xFE])* # JIS X 0208  0ȏ㑱
		(?:[\x00-\x7F\x8E\x8F]|\z)  # ASCII, SS2, SS3 ܂͏I[
		)
	}x;

# EUCł̃p^[}b`
sub Match {
	my $str = shift;
	my $pattern = shift;

	if ($str =~ /$eucpre(?:$pattern)$eucpost}/) {          # p^[}b`
		return 1;
	} else {
		return 0;
	}
}

# EUCł̃p^[u
sub Replace {
	my $str = shift;
	my $pattern = shift;
	my $rep = shift;

	$str =~ s/$eucpre(?:$pattern)$eucpost/$rep/g;     # p^[u

	return $str;
}

# HTMLTj^CY
sub sanitize {
	my $input = $_[0];
	$input = Replace($input,'&','&amp;');   # &  &amp;
	$input = Replace($input,'<','&lt;');    # <  &lt;
	$input = Replace($input,'>','&gt;');    # >  &gt;
	$input = Replace($input,'"','&quot;');  # "  &quot;
	$input = Replace($input,"'",'&#39;');  # '  &#39;
	return $input;
}

# z(擪Ɍ)CSVɕϊ
# (*array,*outstr)
sub array_to_csv {
	my $parray = shift;
	my $pstr   = shift;
	my $datas;
	my $cnt = $#{$parray} + 1;

	${$pstr} = "$cnt,";

	# CSV(_uNH[g܂̓J}܂ޏꍇA""łA"""ɂȂ)
	# QlURL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSVfromValues
	#  @{ $self->{strvals} }; gƒ萔ς]XƂ̂ŁAx[JɏE(xH)
	${$pstr} .= join ',', map {(s/"/""/g or /[\r\n,]/) ? qq("$_") : $_} @{ $parray };

}

# CSVzɕϊ
# (*outstr,*array)
sub csv_to_array {
	my $pstr   = shift;
	my $parray = shift;
	my @values = ();
	my $cnt;


	# zɖ߂
	# QlURL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSV2Values
	{
		my $tmp = ${$pstr};
		$tmp =~ s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		@values = map {/^"(.*)"$/ ? scalar($_ = $1, s/""/"/g, $_) : $_}
		($tmp =~ /("[^"]*(?:""[^"]*)*"|[^,]*),/g);
	}

	# ꉞ`FbNĂ(܂ӖȂ)
	$cnt = shift @values;
	if($cnt != 0){
		@{$parray} = @values;
	} else {
		@{ $parray } = ();
	}

}

# t@CbN
sub my_flock {
	my %lfh = (
		dir => $BD::gLockDir,
		basename => $BD::gLockFile,
		timeout => 60,
		trytime => 10,
		@_);
	$lfh{path} = $lfh{dir} . $lfh{basename};
	for (my $i = 0; $i < $lfh{trytime}; $i++, sleep 1) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
	}
	opendir(LOCKDIR, $lfh{dir});

	my @filelist = readdir(LOCKDIR);

	closedir(LOCKDIR);

	foreach (@filelist) {
	if (/^$lfh{basename}(\d+)/) {
		return \%lfh if (time - $1 > $lfh{timeout} and
		rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
		last;
	}
	}
	undef;
}

# t@CAbN
sub my_funlock {
	rename($_[0]->{current}, $_[0]->{path});
}



1;
